/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the SweepstakePrize type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SweepstakePrize{}

// SweepstakePrize struct for SweepstakePrize
type SweepstakePrize struct {
	Name string `json:"name"`
	WinChance int32 `json:"win_chance"`
	WinChanceType string `json:"win_chance_type"`
}

// NewSweepstakePrize instantiates a new SweepstakePrize object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSweepstakePrize(name string, winChance int32, winChanceType string) *SweepstakePrize {
	this := SweepstakePrize{}
	this.Name = name
	this.WinChance = winChance
	this.WinChanceType = winChanceType
	return &this
}

// NewSweepstakePrizeWithDefaults instantiates a new SweepstakePrize object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSweepstakePrizeWithDefaults() *SweepstakePrize {
	this := SweepstakePrize{}
	return &this
}

// GetName returns the Name field value
func (o *SweepstakePrize) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *SweepstakePrize) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *SweepstakePrize) SetName(v string) {
	o.Name = v
}

// GetWinChance returns the WinChance field value
func (o *SweepstakePrize) GetWinChance() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.WinChance
}

// GetWinChanceOk returns a tuple with the WinChance field value
// and a boolean to check if the value has been set.
func (o *SweepstakePrize) GetWinChanceOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WinChance, true
}

// SetWinChance sets field value
func (o *SweepstakePrize) SetWinChance(v int32) {
	o.WinChance = v
}

// GetWinChanceType returns the WinChanceType field value
func (o *SweepstakePrize) GetWinChanceType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WinChanceType
}

// GetWinChanceTypeOk returns a tuple with the WinChanceType field value
// and a boolean to check if the value has been set.
func (o *SweepstakePrize) GetWinChanceTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WinChanceType, true
}

// SetWinChanceType sets field value
func (o *SweepstakePrize) SetWinChanceType(v string) {
	o.WinChanceType = v
}

func (o SweepstakePrize) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SweepstakePrize) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["win_chance"] = o.WinChance
	toSerialize["win_chance_type"] = o.WinChanceType
	return toSerialize, nil
}

type NullableSweepstakePrize struct {
	value *SweepstakePrize
	isSet bool
}

func (v NullableSweepstakePrize) Get() *SweepstakePrize {
	return v.value
}

func (v *NullableSweepstakePrize) Set(val *SweepstakePrize) {
	v.value = val
	v.isSet = true
}

func (v NullableSweepstakePrize) IsSet() bool {
	return v.isSet
}

func (v *NullableSweepstakePrize) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSweepstakePrize(val *SweepstakePrize) *NullableSweepstakePrize {
	return &NullableSweepstakePrize{value: val, isSet: true}
}

func (v NullableSweepstakePrize) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSweepstakePrize) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


